// NewPingDlg.cpp : implementation file
//				Bill Nolde 2002
//			  billnolde@ieee.org

#include "stdafx.h"
#include "NewPing.h"
#include "NewPingDlg.h"
#include <iphlpapi.h>
#include <winsock2.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

int NewPing(IPAddr ia, ULONG *hops_count, ULONG *rtt);

/////////////////////////////////////////////////////////////////////////////
// CNewPingDlg dialog

CNewPingDlg::CNewPingDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CNewPingDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CNewPingDlg)
	m_ip_address = _T("");
	m_hops_count = 0;
	m_status = _T("");
	m_rtt = 0;
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CNewPingDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CNewPingDlg)
	DDX_Text(pDX, IDC_IPADDRESSEDIT1, m_ip_address);
	DDX_Text(pDX, IDC_HOPPSEDIT3, m_hops_count);
	DDX_Text(pDX, IDC_STATUSEDIT2, m_status);
	DDX_Text(pDX, IDC_RTTEDIT4, m_rtt);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CNewPingDlg, CDialog)
	//{{AFX_MSG_MAP(CNewPingDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_PINGBUTTON1, OnPingbutton)
	ON_BN_CLICKED(IDC_BUTTON2, OnAboutButton)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CNewPingDlg message handlers

BOOL CNewPingDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CNewPingDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CNewPingDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}
//-----------------------------------------------------------------
void CNewPingDlg::OnPingbutton() 
{
int rc;
IPAddr ia;

	MessageBeep(1000);
	UpdateData(TRUE);
	ia = inet_addr (m_ip_address);
	rc = NewPing(ia,(ULONG*)&m_hops_count,(ULONG*)&m_rtt);
	if (rc == 0)	m_status = "Get RTTL and Hops Succeeded";
	else			m_status.Format("Host not responding or no route, rc = %d",rc); 
	UpdateData(FALSE);
	MessageBeep(1000);
	return;	
}
//-------------------------------------------------------------
int NewPing(IPAddr ia, ULONG *hops_count, ULONG *rtt)
{
boolean IsOk;

	IsOk = GetRTTAndHopCount(ia, hops_count,128, rtt);	//the iphlpapi call
	if (IsOk == TRUE)	return 0;
	return  GetLastError();
}
//---------------------------------------------------------------
void CNewPingDlg::OnAboutButton() 
{

	MessageBox("A new Ping Example\n        Bill Nolde\n      billnolde@ieee.org","IP Ping TEST");	

}
//---------------------------------------------------------------
